
/*
 * Copyright (C) 1997 Massachusetts Institute of Technology 
 *
 * This software is being provided by the copyright holders under the
 * following license. By obtaining, using and/or copying this software,
 * you agree that you have read, understood, and will comply with the
 * following terms and conditions:
 *
 * Permission to use, copy, modify, distribute, and sell this software
 * and its documentation for any purpose and without fee or royalty is
 * hereby granted, provided that the full text of this NOTICE appears on
 * ALL copies of the software and documentation or portions thereof,
 * including modifications, that you make.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS," AND COPYRIGHT HOLDERS MAKE NO
 * REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED. BY WAY OF EXAMPLE,
 * BUT NOT LIMITATION, COPYRIGHT HOLDERS MAKE NO REPRESENTATIONS OR
 * WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR PURPOSE OR
 * THAT THE USE OF THE SOFTWARE OR DOCUMENTATION WILL NOT INFRINGE ANY
 * THIRD PARTY PATENTS, COPYRIGHTS, TRADEMARKS OR OTHER RIGHTS. COPYRIGHT
 * HOLDERS WILL BEAR NO LIABILITY FOR ANY USE OF THIS SOFTWARE OR
 * DOCUMENTATION.
 *
 * The name and trademarks of copyright holders may NOT be used in
 * advertising or publicity pertaining to the software without specific,
 * written prior permission. Title to copyright in this software and any
 * associated documentation will at all times remain with copyright
 * holders. See the file AUTHORS which should have accompanied this software
 * for a list of all copyright holders.
 *
 * This file may be derived from previously copyrighted software. This
 * copyright applies only to those changes made by the copyright
 * holders listed in the AUTHORS file. The rest of this file is covered by
 * the copyright notices, if any, listed below.
 */

#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/ioctl.h>
/* #include <sys/disklabel.h> */
#include <sys/socket.h>
#include <netinet/in.h>
#include <sys/tty.h>
#include <sys/ioctl_compat.h>
/* #include <net/route.h>
#include <net/if.h>
#include <netinet/ip_mroute.h> */
#include "ioctl_table.h"

#define PRIOCTL(x,y) if ((x) == req) return y;
char *get_ioctl_req(u32 req) {
/*
PRIOCTL(DIOCGDINFO,"DIOCGDINFO");
PRIOCTL(DIOCSDINFO,"DIOCSDINFO");
PRIOCTL(DIOCWDINFO,"DIOCWDINFO");
PRIOCTL(DIOCGPART,"DIOCGPART");
PRIOCTL(DIOCRFORMAT,"DIOCRFORMAT");
PRIOCTL(DIOCWFORMAT,"DIOCWFORMAT");
*/
PRIOCTL(DIOCSSTEP,"DIOCSSTEP");
PRIOCTL(DIOCSRETRIES,"DIOCSRETRIES");
PRIOCTL(DIOCWLABEL,"DIOCWLABEL");
/*
PRIOCTL(DIOCSBAD,"DIOCSBAD");
*/
PRIOCTL(DIOCEJECT,"DIOCEJECT");
PRIOCTL(DIOCLOCK,"DIOCLOCK");
PRIOCTL(FIOCLEX,"FIOCLEX");
PRIOCTL(FIONCLEX,"FIONCLEX");
PRIOCTL(FIONREAD,"FIONREAD");
PRIOCTL(FIONBIO,"FIONBIO");
PRIOCTL(FIOASYNC,"FIOASYNC");
PRIOCTL(FIOSETOWN,"FIOSETOWN");
PRIOCTL(FIOGETOWN,"FIOGETOWN");
PRIOCTL(SIOCSHIWAT,"SIOCSHIWAT");
PRIOCTL(SIOCGHIWAT,"SIOCGHIWAT");
PRIOCTL(SIOCSLOWAT,"SIOCSLOWAT");
PRIOCTL(SIOCGLOWAT,"SIOCGLOWAT");
PRIOCTL(SIOCATMARK,"SIOCATMARK");
PRIOCTL(SIOCSPGRP,"SIOCSPGRP");
PRIOCTL(SIOCGPGRP,"SIOCGPGRP");
/*
PRIOCTL(SIOCADDRT,"SIOCADDRT");
PRIOCTL(SIOCDELRT,"SIOCDELRT");
PRIOCTL(SIOCSIFADDR,"SIOCSIFADDR");
PRIOCTL(OSIOCGIFADDR,"OSIOCGIFADDR");
PRIOCTL(SIOCGIFADDR,"SIOCGIFADDR");
PRIOCTL(SIOCSIFDSTADDR,"SIOCSIFDSTADDR");
PRIOCTL(OSIOCGIFDSTADDR,"OSIOCGIFDSTADDR");
PRIOCTL(SIOCGIFDSTADDR,"SIOCGIFDSTADDR");
PRIOCTL(SIOCSIFFLAGS,"SIOCSIFFLAGS");
PRIOCTL(SIOCGIFFLAGS,"SIOCGIFFLAGS");
PRIOCTL(OSIOCGIFBRDADDR,"OSIOCGIFBRDADDR");
PRIOCTL(SIOCGIFBRDADDR,"SIOCGIFBRDADDR");
PRIOCTL(SIOCSIFBRDADDR,"SIOCSIFBRDADDR");
PRIOCTL(OSIOCGIFCONF,"OSIOCGIFCONF");
PRIOCTL(SIOCGIFCONF,"SIOCGIFCONF");
PRIOCTL(OSIOCGIFNETMASK,"OSIOCGIFNETMASK");
PRIOCTL(SIOCGIFNETMASK,"SIOCGIFNETMASK");
PRIOCTL(SIOCSIFNETMASK,"SIOCSIFNETMASK");
PRIOCTL(SIOCGIFMETRIC,"SIOCGIFMETRIC");
PRIOCTL(SIOCSIFMETRIC,"SIOCSIFMETRIC");
PRIOCTL(SIOCDIFADDR,"SIOCDIFADDR");
PRIOCTL(SIOCAIFADDR,"SIOCAIFADDR");
PRIOCTL(SIOCADDMULTI,"SIOCADDMULTI");
PRIOCTL(SIOCDELMULTI,"SIOCDELMULTI");
PRIOCTL(SIOCGETVIFCNT,"SIOCGETVIFCNT");
PRIOCTL(SIOCGETSGCNT,"SIOCGETSGCNT");
PRIOCTL(SIOCSIFMTU,"SIOCSIFMTU");
PRIOCTL(SIOCGIFMTU,"SIOCGIFMTU");
PRIOCTL(SIOCSIFASYNCMAP,"SIOCSIFASYNCMAP");
PRIOCTL(SIOCGIFASYNCMAP,"SIOCGIFASYNCMAP");
*/
PRIOCTL(TIOCPKT_IOCTL,"TIOCPKT_IOCTL");
PRIOCTL(TIOCSTOP,"TIOCSTOP");
PRIOCTL(TIOCSTART,"TIOCSTART");
PRIOCTL(TIOCMSET,"TIOCMSET");
PRIOCTL(TIOCMBIS,"TIOCMBIS");
PRIOCTL(TIOCMBIC,"TIOCMBIC");
PRIOCTL(TIOCMGET,"TIOCMGET");
PRIOCTL(TIOCREMOTE,"TIOCREMOTE");
PRIOCTL(TIOCGWINSZ,"TIOCGWINSZ");
PRIOCTL(TIOCSWINSZ,"TIOCSWINSZ");
PRIOCTL(TIOCUCNTL,"TIOCUCNTL");
PRIOCTL(TIOCSTAT,"TIOCSTAT");
PRIOCTL(TIOCCONS,"TIOCCONS");
PRIOCTL(TIOCSCTTY,"TIOCSCTTY");
PRIOCTL(TIOCEXT,"TIOCEXT");
PRIOCTL(TIOCSIG,"TIOCSIG");
PRIOCTL(TIOCDRAIN,"TIOCDRAIN");
PRIOCTL(TIOCGFLAGS,"TIOCGFLAGS");
PRIOCTL(TIOCSFLAGS,"TIOCSFLAGS");
PRIOCTL(TIOCFLAG_SOFTCAR,"TIOCFLAG_SOFTCAR");
PRIOCTL(TIOCFLAG_CLOCAL,"TIOCFLAG_CLOCAL");
PRIOCTL(TIOCFLAG_CRTSCTS,"TIOCFLAG_CRTSCTS");
PRIOCTL(TIOCFLAG_MDMBUF,"TIOCFLAG_MDMBUF");
PRIOCTL(TIOCMODG,"TIOCMODG");
PRIOCTL(TIOCMODS,"TIOCMODS");
/* from sys/ttycom.h */
PRIOCTL(TIOCEXCL,"TIOCEXCL");
PRIOCTL(TIOCNXCL,"TIOCNXCL");
PRIOCTL(TIOCFLUSH,"TIOCFLUSH");
PRIOCTL(TIOCGETA,"TIOCGETA");
PRIOCTL(TIOCSETA,"TIOCSETA");
PRIOCTL(TIOCSETAW,"TIOCSETAW");
PRIOCTL(TIOCSETAF,"TIOCSETAF");
PRIOCTL(TIOCGETD,"TIOCGETD");
PRIOCTL(TIOCSETD,"TIOCSETD");
PRIOCTL(TIOCSBRK,"TIOCSBRK");
PRIOCTL(TIOCCBRK,"TIOCCBRK");
PRIOCTL(TIOCSDTR,"TIOCSDTR");
PRIOCTL(TIOCCDTR,"TIOCCDTR");
PRIOCTL(TIOCGPGRP,"TIOCGPGRP");
PRIOCTL(TIOCSPGRP,"TIOCSPGRP");
PRIOCTL(TIOCOUTQ,"TIOCOUTQ");
PRIOCTL(TIOCSTI,"TIOCSTI");
PRIOCTL(TIOCNOTTY,"TIOCNOTTY");
PRIOCTL(TIOCPKT,"TIOCPKT");
PRIOCTL(TIOCSTOP,"TIOCSTOP");
PRIOCTL(TIOCSTART,"TIOCSTART");
PRIOCTL(TIOCMSET,"TIOCMSET");
PRIOCTL(TIOCMBIS,"TIOCMBIS");
PRIOCTL(TIOCMBIC,"TIOCMBIC");
PRIOCTL(TIOCMGET,"TIOCMGET");
PRIOCTL(TIOCREMOTE,"TIOCREMOTE");
PRIOCTL(TIOCGWINSZ,"TIOCGWINSZ");
PRIOCTL(TIOCSWINSZ,"TIOCSWINSZ");
PRIOCTL(TIOCUCNTL,"TIOCUCNTL");
PRIOCTL(TIOCSTAT,"TIOCSTAT");
PRIOCTL(TIOCCONS,"TIOCCONS");
PRIOCTL(TIOCSCTTY,"TIOCSCTTY");
PRIOCTL(TIOCEXT,"TIOCEXT");
PRIOCTL(TIOCSIG,"TIOCSIG");
PRIOCTL(TIOCDRAIN,"TIOCDRAIN");
PRIOCTL(TIOCGFLAGS,"TIOCGFLAGS");
PRIOCTL(TIOCSFLAGS,"TIOCSFLAGS");
/* from sys/ioctl_compat.h */
PRIOCTL(OTIOCGETD,"OTIOCGETD");
PRIOCTL(OTIOCSETD,"OTIOCSETD");
PRIOCTL(TIOCHPCL,"TIOCHPCL");
PRIOCTL(TIOCGETP,"TIOCGETP");
PRIOCTL(TIOCSETP,"TIOCSETP");
PRIOCTL(TIOCSETN,"TIOCSETN");
PRIOCTL(TIOCSETC,"TIOCSETC");
PRIOCTL(TIOCGETC,"TIOCGETC");
PRIOCTL(TIOCLBIS,"TIOCLBIS");
PRIOCTL(TIOCLBIC,"TIOCLBIC");
PRIOCTL(TIOCLSET,"TIOCLSET");
PRIOCTL(TIOCLGET,"TIOCLGET");
PRIOCTL(TIOCSLTC,"TIOCSLTC");
PRIOCTL(TIOCGLTC,"TIOCGLTC");
PRIOCTL(OTIOCCONS,"OTIOCCONS");

return 0;
}
